/*!
 * wbm-bacnet@1.3.4
 * 
 *   Copyright © 2020 WAGO Kontakttechnik GmbH & Co. KG
 * 
 *   License: 
 *     WAGO Software License Agreement
 * 
 *   Contributors:
 *     
 * 
 *   Description:
 *     BACnet Configuration
 * 
 *   
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?exports.bacnet=t():e.bacnet=t()}(window,(function(){return function(e){var t={};function n(i){if(t[i])return t[i].exports;var a=t[i]={i:i,l:!1,exports:{}};return e[i].call(a.exports,a,a.exports,n),a.l=!0,a.exports}return n.m=e,n.c=t,n.d=function(e,t,i){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:i})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var i=Object.create(null);if(n.r(i),Object.defineProperty(i,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var a in e)n.d(i,a,function(t){return e[t]}.bind(null,a));return i},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=2)}([function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),function(e){e.admin="admin",e.user="user",e.guest="guest"}(t.UserRoles||(t.UserRoles={}))},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e){this.base=e}return e.prototype.onRouteChange=function(e){},e.prototype.unload=function(){},e}();t.ViewController=i},function(e,t,n){"use strict";var i=this&&this.__assign||function(){return(i=Object.assign||function(e){for(var t,n=1,i=arguments.length;n<i;n++)for(var a in t=arguments[n])Object.prototype.hasOwnProperty.call(t,a)&&(e[a]=t[a]);return e}).apply(this,arguments)},a=this&&this.__awaiter||function(e,t,n,i){return new(n||(n=Promise))((function(a,o){function r(e){try{s(i.next(e))}catch(e){o(e)}}function l(e){try{s(i.throw(e))}catch(e){o(e)}}function s(e){var t;e.done?a(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(r,l)}s((i=i.apply(e,t||[])).next())}))},o=this&&this.__generator||function(e,t){var n,i,a,o,r={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;r;)try{if(n=1,i&&(a=2&o[0]?i.return:o[0]?i.throw||((a=i.return)&&a.call(i),0):i.next)&&!(a=a.call(i,o[1])).done)return a;switch(i=0,a&&(o=[2&o[0],a.value]),o[0]){case 0:case 1:a=o;break;case 4:return r.label++,{value:o[1],done:!1};case 5:r.label++,i=o[1],o=[0];continue;case 7:o=r.ops.pop(),r.trys.pop();continue;default:if(!(a=r.trys,(a=a.length>0&&a[a.length-1])||6!==o[0]&&2!==o[0])){r=0;continue}if(3===o[0]&&(!a||o[1]>a[0]&&o[1]<a[3])){r.label=o[1];break}if(6===o[0]&&r.label<a[1]){r.label=a[1],a=o;break}if(a&&r.label<a[2]){r.label=a[2],r.ops.push(o);break}a[2]&&r.ops.pop(),r.trys.pop();continue}o=t.call(e,r)}catch(e){o=[6,e],i=0}finally{n=a=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}};Object.defineProperty(t,"__esModule",{value:!0});var r=n(0),l=n(3),s=n(5),c=n(9),u=n(11),d=n(14);base.plugin.register("wbm-bacnet",(function(e){return a(this,void 0,void 0,(function(){var t,n,a,f,p,h,b;return o(this,(function(o){return t={id:"bacnet",title:{fallback:"BACnet",key:"title-bacnet"},description:{fallback:"Configuration of BACnet",key:"description-bacnet"},priority:80,userRoles:[r.UserRoles.admin]},n=e.subframeGenerator.createSubFrame(t.id,e,[]),a=l.initializeBacnetStatus(e),n.registerSubMenuItem(a.item,a.controller),f=s.initializeBacnetConfig(e),n.registerSubMenuItem(f.item,f.controller),p=c.initializeBacnetStorage(e),n.registerSubMenuItem(p.item,p.controller),h=u.initializeBacnetFile(e),n.registerSubMenuItem(h.item,h.controller),b=d.initializeBacnetDiag(e),n.registerSubMenuItem(b.item,b.controller),[2,i(i({},t),{controller:n})]}))}))}))},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=n(0);t.initializeBacnetStatus=function(e){var t={id:"bacnet-status",title:e.localization.localized({fallback:"Status",key:"title-bacnet-status"}),tooltip:e.localization.localized({fallback:"Status of BACnet",key:"description-bacnet-status"}),priority:700,userRoles:[i.UserRoles.admin]},a=n(4);return{item:t,controller:e.viewGenerator.generate(e,a)}}},function(e){e.exports=JSON.parse('{"title":{"default":"BACnet Status","localized":"page-title-bacnet-status"},"note":{"default":"BACnet is only available when e!RUNTIME is activated.","localized":"page-note-bacnet-status"},"content":[{"title":{"default":"BACnet Information","localized":"title-bacnet-info"},"sections":[{"fields":[{"title":{"default":"State","localized":"bacnet-current-state-label"},"control":{"type":"checkbox"},"parameter":"bacnet.current.state","options":{"readonly":true}},{"title":{"default":"Status Info","localized":"bacnet-status-info-label"},"control":{"type":"textfield"},"parameter":"bacnet.status.info","options":{"readonly":true}},{"title":{"default":"Device ID","localized":"bacnet-device-id-label"},"control":{"type":"textfield"},"parameter":"bacnet.device.id","options":{"readonly":true}}]}]},{"title":{"default":"BACnet License","localized":"title-bacnet-license"},"sections":[{"fields":[{"title":{"default":"Type","localized":"bacnet-license-name-label"},"control":{"type":"textfield"},"parameter":"bacnet.license.name","options":{"readonly":true}},{"title":{"default":"User Objects","localized":"bacnet-license-info-label"},"control":{"type":"textfield"},"parameter":"bacnet.license.info","options":{"readonly":true}}]}]}]}')},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=n(0),a=n(6);t.initializeBacnetConfig=function(e){return{item:{id:"bacnet-config",title:e.localization.localized({fallback:"Configuration",key:"title-bacnet-config"}),tooltip:e.localization.localized({fallback:"Configuration of BACnet Service",key:"description-bacnet-config"}),priority:600,userRoles:[i.UserRoles.admin]},controller:e.viewGenerator.generate(e,a.default(e))}}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=n(7);t.default=function(e){return{title:{default:"BACnet Configuration",localized:"page-title-bacnet-configuration"},note:{default:"Changes will take effect after next controller reboot or runtime restart.",localized:"page-note-bacnet-configuration"},content:[{title:{default:"BACnet Service",localized:"title-bacnet-settings"},sections:[{fields:[{title:{default:"Service active",localized:"bacnet-config-state-label"},control:{type:"checkbox"},parameter:"bacnet.config.state"}]},new i.RestartForm(e)]},{title:{default:"BACnet Settings",localized:"title-bacnet-settings"},sections:[{fields:[{title:{default:"Port number",localized:"bacnet-udp-port-label"},control:{type:"textfield"},parameter:"bacnet.udp.port"},{title:{default:"Who Is online interval time (sec)",localized:"bacnet-who-is-online-interval-label"},control:{type:"textfield"},parameter:"bacnet.who.is.online.interval"}]}]},{title:{default:"BACnet Data Reset",localized:"title-bacnet-reset"},sections:[{fields:[{title:{default:"Delete Persistence Data",localized:"bacnet-reset-persistence-delete-label"},control:{type:"checkbox"},parameter:"bacnet.persistence.delete"},{title:{default:"Reset all BACnet Data and Settings to Default",localized:"bacnet-reset-delete-all-label"},control:{type:"checkbox"},parameter:"bacnet.delete.all"}]}]}]}}},function(e,t,n){"use strict";var i,a=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},function(e,t){function n(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}),o=this&&this.__awaiter||function(e,t,n,i){return new(n||(n=Promise))((function(a,o){function r(e){try{s(i.next(e))}catch(e){o(e)}}function l(e){try{s(i.throw(e))}catch(e){o(e)}}function s(e){var t;e.done?a(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(r,l)}s((i=i.apply(e,t||[])).next())}))},r=this&&this.__generator||function(e,t){var n,i,a,o,r={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;r;)try{if(n=1,i&&(a=2&o[0]?i.return:o[0]?i.throw||((a=i.return)&&a.call(i),0):i.next)&&!(a=a.call(i,o[1])).done)return a;switch(i=0,a&&(o=[2&o[0],a.value]),o[0]){case 0:case 1:a=o;break;case 4:return r.label++,{value:o[1],done:!1};case 5:r.label++,i=o[1],o=[0];continue;case 7:o=r.ops.pop(),r.trys.pop();continue;default:if(!(a=r.trys,(a=a.length>0&&a[a.length-1])||6!==o[0]&&2!==o[0])){r=0;continue}if(3===o[0]&&(!a||o[1]>a[0]&&o[1]<a[3])){r.label=o[1];break}if(6===o[0]&&r.label<a[1]){r.label=a[1],a=o;break}if(a&&r.label<a[2]){r.label=a[2],r.ops.push(o);break}a[2]&&r.ops.pop(),r.trys.pop();continue}o=t.call(e,r)}catch(e){o=[6,e],i=0}finally{n=a=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}};Object.defineProperty(t,"__esModule",{value:!0});var l=n(1),s=n(8),c=function(e){function t(t){var n=e.call(this,t)||this;return n.view=document.createElement("wbm-bacnet-restart-form"),n}return a(t,e),t.prototype.load=function(){return o(this,void 0,void 0,(function(){var e=this;return r(this,(function(t){return this.view.innerHTML='\n            <div class="section titled-section">\n                <span class="title" taid="section-title-restart">Runtime restart</span>\n                <div class="field" taid="field-restart-label" >\n                    <div class="control">\n                    </div>\n                    <button taid="action-restart" class="action">Restart</button>\n                </div>\n            </div>\n        ',this.view.querySelector("button").addEventListener("click",(function(){return e.restartButtonPressed()})),[2]}))}))},t.prototype.restartButtonPressed=function(){return o(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.base.modalPresenter.showDialog(this.base,{title:this.base.localization.localized({fallback:"Restart",key:"restart-prompt-modal-title"}),message:this.base.localization.localized({fallback:"Do you really want to restart the runtime?",key:"restart-prompt-modal-message"}),primaryButton:{title:"Restart",style:s.DialogButtonStyle.action},secondaryButton:s.DialogButton.cancel})];case 1:return e.sent()!=s.DialogButtonType.primary?[3,3]:[4,this.base.modalPresenter.showLoadingDialog(this.base,{title:"Restarting runtime..."},this.doRestartRuntime())];case 2:e.sent(),e.label=3;case 3:return[2]}}))}))},t.prototype.doRestartRuntime=function(){return o(this,void 0,void 0,(function(){var e,t;return r(this,(function(n){switch(n.label){case 0:return n.trys.push([0,2,,3]),[4,this.base.parameter.execute("bacnet.config.restart")];case 1:if((e=n.sent()).error)throw e.error;return[3,3];case 2:return t=n.sent(),[2,this.base.modalPresenter.showErrorDialog(this.base,{title:this.base.localization.localized({key:"config-restart-error-title",fallback:"Restart runtime failed"}),message:this.base.localization.localized({key:"config-restart-error-message",fallback:"Could not restart the runtime"}),detailMessage:t.message})];case 3:return[2]}}))}))},t}(l.ViewController);t.RestartForm=c},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),function(e){e.primary="primary",e.secondary="secondary"}(t.DialogButtonType||(t.DialogButtonType={})),function(e){e.default="default",e.action="action"}(t.DialogButtonStyle||(t.DialogButtonStyle={})),function(e){e.okay="okay",e.cancel="cancel"}(t.DialogButton||(t.DialogButton={})),function(e){e.default="default",e.info="info",e.warning="warning",e.error="error"}(t.DialogStyle||(t.DialogStyle={}))},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=n(0);t.initializeBacnetStorage=function(e){var t={id:"bacnet-storage",title:e.localization.localized({fallback:"Storage Location",key:"title-bacnet-storage"}),tooltip:e.localization.localized({fallback:"Configuration of Storage BACnet",key:"description-bacnet-storage"}),priority:500,userRoles:[i.UserRoles.admin]},a=n(10);return{item:t,controller:e.viewGenerator.generate(e,a)}}},function(e){e.exports=JSON.parse('{"title":{"default":"BACnet Storage Location","localized":"page-title-bacnet-storage"},"note":{"default":"Changes will take effect immediately.","localized":"page-note-bacnet-storage"},"content":[{"title":{"default":"BACnet Persistence","localized":"title-bacnet-storage-persistence"},"sections":[{"fields":[{"title":{"default":"Storage location:","localized":"bacnet-storage-persistence-label"},"parameter":"bacnet.storage.persistence","control":{"type":"dropdown","items":[{"title":{"default":"Internal Flash","localized":"default-persistence-dropdown-item-internal-flash"},"value":"internal-flash"},{"title":{"default":"SD Card","localized":"default-persistence-dropdown-item-sd-card"},"value":"sd-card","hidden":"bacnet.storage.options is 0"}]}}],"confirm":{"title":{"default":"Attention","key":"bacnet-storage-persistence-confirm-title"},"message":{"default":"Really want to change persistence storage location? Important note: Please do not turn off or restart the controller after changing the storage location within the following 30s. Otherwise data will be lost.","key":"bacnet-storage-persistence-confirm-message"}}}]},{"title":{"default":"BACnet Trendlog","localized":"title-bacnet-storage-trendlog"},"sections":[{"fields":[{"title":{"default":"Storage location:","localized":"bacnet-storage-trendlog-label"},"parameter":"bacnet.storage.trendlog","control":{"type":"dropdown","items":[{"title":{"default":"Internal Flash","localized":"default-trendlog-dropdown-item-internal-flash"},"value":"internal-flash"},{"title":{"default":"SD Card","localized":"default-trendlog-dropdown-item-sd-card"},"value":"sd-card","hidden":"bacnet.storage.options is 0"}]}}],"confirm":{"title":{"default":"Attention","key":"bacnet-storage-trendlog-confirm-title"},"message":{"default":"Really want to change trendlog storage location? Important note: Data will be lost","key":"bacnet-storage-trendlog-confirm-message"}}}]},{"title":{"default":"BACnet Eventlog","localized":"title-bacnet-storage-eventlog"},"sections":[{"fields":[{"title":{"default":"Storage location:","localized":"bacnet-storage-eventlog-label"},"parameter":"bacnet.storage.eventlog","control":{"type":"dropdown","items":[{"title":{"default":"Internal Flash","localized":"default-eventlog-dropdown-item-internal-flash"},"value":"internal-flash"},{"title":{"default":"SD Card","localized":"default-eventlog-dropdown-item-sd-card"},"value":"sd-card","hidden":"bacnet.storage.options is 0"}]}}],"confirm":{"title":{"default":"Attention","key":"bacnet-storage-eventlog-confirm-title"},"message":{"default":"Really want to change eventlog storage location? Important note: Data will be lost","key":"bacnet-storage-eventlog-confirm-message"}}}]}]}')},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=n(0),a=n(12);t.initializeBacnetFile=function(e){return{item:{id:"bacnet-file",title:e.localization.localized({fallback:"Files",key:"title-bacnet-file"}),tooltip:e.localization.localized({fallback:"Files of BACnet",key:"description-bacnet-file"}),priority:400,userRoles:[i.UserRoles.admin]},controller:e.viewGenerator.generate(e,a.default(e))}}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=n(13);t.default=function(e){return{title:{default:"BACnet Files",localized:"configuration-file-page-title"},note:{default:"Changes will take effect after the next controller reboot or runtime restart."},content:[{title:{default:"BACnet override.xml",localized:"title-file-override-xml"},sections:[new i.UploadForm(e,"overridexml")]}]}}},function(e,t,n){"use strict";var i,a=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},function(e,t){function n(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}),o=this&&this.__awaiter||function(e,t,n,i){return new(n||(n=Promise))((function(a,o){function r(e){try{s(i.next(e))}catch(e){o(e)}}function l(e){try{s(i.throw(e))}catch(e){o(e)}}function s(e){var t;e.done?a(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(r,l)}s((i=i.apply(e,t||[])).next())}))},r=this&&this.__generator||function(e,t){var n,i,a,o,r={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;r;)try{if(n=1,i&&(a=2&o[0]?i.return:o[0]?i.throw||((a=i.return)&&a.call(i),0):i.next)&&!(a=a.call(i,o[1])).done)return a;switch(i=0,a&&(o=[2&o[0],a.value]),o[0]){case 0:case 1:a=o;break;case 4:return r.label++,{value:o[1],done:!1};case 5:r.label++,i=o[1],o=[0];continue;case 7:o=r.ops.pop(),r.trys.pop();continue;default:if(!(a=r.trys,(a=a.length>0&&a[a.length-1])||6!==o[0]&&2!==o[0])){r=0;continue}if(3===o[0]&&(!a||o[1]>a[0]&&o[1]<a[3])){r.label=o[1];break}if(6===o[0]&&r.label<a[1]){r.label=a[1],a=o;break}if(a&&r.label<a[2]){r.label=a[2],r.ops.push(o);break}a[2]&&r.ops.pop(),r.trys.pop();continue}o=t.call(e,r)}catch(e){o=[6,e],i=0}finally{n=a=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}};Object.defineProperty(t,"__esModule",{value:!0});var l=function(e){function t(t,n){var i=e.call(this,t)||this;return i.view=document.createElement("wbm-bacnet-upload-form"),i.name=n,i}return a(t,e),t.prototype.load=function(){return o(this,void 0,void 0,(function(){var e,t,n,i=this;return r(this,(function(a){return{overridexml:"override.xml",bacconfigini:"bacconfig.ini"},this.view.innerHTML='\n            <div class="section">\n                <div class="field" taid="field-'+this.name+'-upload-label" >\n                    <div class="control">\n                        <label class="file-input" data-placeholder="Choose file..." data-filename=""><input type="file" taid="field-control"></label>\n                    </div>\n                    <button taid="action-'+this.name+'-upload" class="action" disabled="disabled">Upload</button>\n                </div>\n            </div>\n        ',(e=this.view.querySelector("button")).addEventListener("click",(function(){return i.uploadButtonPressed()})),t=this.view.querySelector("input"),n=this.view.querySelector("label.file-input"),t.addEventListener("change",(function(){var i=t.files&&t.files.length&&t.files[0].name||"";n.setAttribute("data-filename",i),e.disabled=!i})),[2]}))}))},t.prototype.uploadButtonPressed=function(){return o(this,void 0,void 0,(function(){var e,t,n,i,a,o;return r(this,(function(r){switch(r.label){case 0:(e=this.view.querySelector("div.section")).classList.add("submitting"),t=this.view.querySelector("input"),n=t.files[0],r.label=1;case 1:return r.trys.push([1,3,,4]),[4,this.base.transfer.upload([n],"/tmp/bacnet_upload")];case 2:return r.sent(),[3,4];case 3:return i=r.sent(),e.classList.remove("submitting"),[2,this.base.modalPresenter.showErrorDialog(this.base,{title:this.base.localization.localized({key:this.name+"-upload-failed-error-modal-title",fallback:"Upload failed"}),message:this.base.localization.localized({key:this.name+"-upload-failed-error-modal-message",fallback:"Could not upload the file"}),detailMessage:i.message})];case 4:return r.trys.push([4,6,,7]),[4,this.base.parameter.execute("bacnet.file.upload.copy",{filename:n.name})];case 5:if((a=r.sent()).error)throw a.error;return[3,7];case 6:return o=r.sent(),this.base.transfer.cleanUp(),e.classList.remove("submitting"),[2,this.base.modalPresenter.showErrorDialog(this.base,{title:this.base.localization.localized({key:this.name+"-upload-failed-error-modal-title",fallback:"Installation failed"}),message:this.base.localization.localized({key:this.name+"-copy-failed-error-modal-message",fallback:"Could not copy the uploaded file"}),detailMessage:o.message})];case 7:return t.value="",t.dispatchEvent(new Event("change")),e.classList.remove("submitting"),[2]}}))}))},t}(n(1).ViewController);t.UploadForm=l},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=n(0),a=n(15);t.initializeBacnetDiag=function(e){var t={id:"bacnet-diag",title:e.localization.localized({fallback:"Diagnostic",key:"title-bacnet-diag"}),tooltip:e.localization.localized({fallback:"Diagnostic of BACnet",key:"description-bacnet-diag"}),priority:100,userRoles:[i.UserRoles.admin]},n={title:{default:"BACnet Diagnostic",localized:"bacnet-diag-page-title"},content:[new a.BACNET_DIAG(e)]};return{item:t,controller:e.viewGenerator.generate(e,n)}}},function(e,t,n){"use strict";var i,a=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},function(e,t){function n(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}),o=this&&this.__awaiter||function(e,t,n,i){return new(n||(n=Promise))((function(a,o){function r(e){try{s(i.next(e))}catch(e){o(e)}}function l(e){try{s(i.throw(e))}catch(e){o(e)}}function s(e){var t;e.done?a(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(r,l)}s((i=i.apply(e,t||[])).next())}))},r=this&&this.__generator||function(e,t){var n,i,a,o,r={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return o={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function l(o){return function(l){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;r;)try{if(n=1,i&&(a=2&o[0]?i.return:o[0]?i.throw||((a=i.return)&&a.call(i),0):i.next)&&!(a=a.call(i,o[1])).done)return a;switch(i=0,a&&(o=[2&o[0],a.value]),o[0]){case 0:case 1:a=o;break;case 4:return r.label++,{value:o[1],done:!1};case 5:r.label++,i=o[1],o=[0];continue;case 7:o=r.ops.pop(),r.trys.pop();continue;default:if(!(a=r.trys,(a=a.length>0&&a[a.length-1])||6!==o[0]&&2!==o[0])){r=0;continue}if(3===o[0]&&(!a||o[1]>a[0]&&o[1]<a[3])){r.label=o[1];break}if(6===o[0]&&r.label<a[1]){r.label=a[1],a=o;break}if(a&&r.label<a[2]){r.label=a[2],r.ops.push(o);break}a[2]&&r.ops.pop(),r.trys.pop();continue}o=t.call(e,r)}catch(e){o=[6,e],i=0}finally{n=a=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,l])}}};Object.defineProperty(t,"__esModule",{value:!0});var l=n(1);n(16);var s=function(e){function t(t){var n=e.call(this,t)||this;return n.didLoad=!1,n.isPeriodicallyRefreshing=!1,n.view=document.createElement("wbm-bacnet-diag"),n}return a(t,e),Object.defineProperty(t.prototype,"checkboxReadLast",{get:function(){return this.view.querySelector('[taid="field-limit"] input[type="checkbox"]')},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"textfieldReadLast",{get:function(){return this.view.querySelector('[taid="field-limit"] input[type="text"]')},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"checkboxAutoRefresh",{get:function(){return this.view.querySelector('[taid="field-automatic-refresh-interval"] input[type="checkbox"]')},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"textfieldAutoRefresh",{get:function(){return this.view.querySelector('[taid="field-automatic-refresh-interval"] input[type="text"]')},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"refreshButton",{get:function(){return this.view.querySelector("button")},enumerable:!0,configurable:!0}),t.prototype.updateDisabledStates=function(){this.isPeriodicallyRefreshing?(this.checkboxReadLast.disabled=!0,this.textfieldReadLast.disabled=!0,this.checkboxAutoRefresh.disabled=!0,this.textfieldAutoRefresh.disabled=!0):(this.textfieldReadLast.disabled=!this.checkboxReadLast.checked,this.textfieldAutoRefresh.disabled=!this.checkboxAutoRefresh.checked,this.checkboxReadLast.disabled=!1,this.checkboxAutoRefresh.disabled=!1)},t.prototype.updateButtonName=function(){this.checkboxAutoRefresh.checked?this.isPeriodicallyRefreshing?this.refreshButton.innerText="Stop":this.refreshButton.innerText="Start":this.refreshButton.innerText="Refresh"},t.prototype.updateLocalizables=function(){var e=this.view.querySelector('[taid="form-title"]'),t=this.view.querySelector('[taid="field-limit"] label'),n=this.view.querySelector('[taid="field-automatic-refresh-interval"] label');e.innerText=this.base.localization.localized({fallback:e.innerText,key:"form-bacnet-diag-title"}),t.innerText=this.base.localization.localized({fallback:t.innerText,key:"field-bacnet-diag-limit"}),n.innerText=this.base.localization.localized({fallback:n.innerText,key:"field-bacnet-diag-auto-refresh"})},t.prototype.load=function(){return o(this,void 0,void 0,(function(){var e=this;return r(this,(function(t){return this.didLoad||(this.view.innerHTML=n(20),this.updateLocalizables(),this.updateButtonName(),this.updateDisabledStates(),this.checkboxReadLast.addEventListener("change",(function(){return e.updateDisabledStates()})),this.checkboxAutoRefresh.addEventListener("change",(function(){e.updateDisabledStates(),e.updateButtonName()})),this.refreshButton.addEventListener("click",(function(){var t=parseInt(e.textfieldAutoRefresh.value);(t<1||isNaN(t))&&(t=1),e.textfieldAutoRefresh.value=""+t;var n=e.checkboxReadLast.checked,i=parseInt(e.textfieldReadLast.value);(i<1||isNaN(i))&&(i=1),e.textfieldReadLast.value=""+i,e.checkboxAutoRefresh.checked?e.isPeriodicallyRefreshing?e.stopRefreshingReriodically():e.startRefreshingPeriodically(t,n?i:0):e.refreshOnce(n?i:0),e.updateButtonName(),e.updateDisabledStates()}))),this.didLoad=!0,[2]}))}))},t.prototype.unload=function(){return o(this,void 0,void 0,(function(){return r(this,(function(e){return this.stopRefreshingReriodically(),this.view.innerHTML="",this.didLoad=!1,[2]}))}))},t.prototype.refreshOnce=function(e){return void 0===e&&(e=0),o(this,void 0,void 0,(function(){var t,n,i,a;return r(this,(function(o){switch(o.label){case 0:return t=this.view.querySelector("textarea"),(n=this.view.querySelector("div.indicator")).style.display="",t.style.opacity="0.5",[4,this.base.parameter.execute("bacdiag.getlog",{limit:""+e})];case 1:return(i=o.sent()).error?(this.base.modalPresenter.showErrorDialog(this.base,{title:this.base.localization.localized({fallback:"Fetching log failed",key:"fetching-log-failed-modal-title"}),message:this.base.localization.localized({fallback:"An error occured when trying to fetch the logs",key:"fetching-log-failed-modal-message"}),detailMessage:i.error.message}),this.stopRefreshingReriodically(),this.updateButtonName(),this.updateDisabledStates()):(a=i.returnValue||"",t.value=a,n.style.display="none",t.style.opacity="",t.style.overflow="auto"),[2]}}))}))},t.prototype.startRefreshingPeriodically=function(e,t){return void 0===t&&(t=0),o(this,void 0,void 0,(function(){return r(this,(function(n){switch(n.label){case 0:this.isPeriodicallyRefreshing&&this.stopRefreshingReriodically(),this.isPeriodicallyRefreshing=!0,n.label=1;case 1:return this.isPeriodicallyRefreshing?[4,this.refreshOnce(t)]:[3,4];case 2:return n.sent(),[4,new Promise((function(t){return setTimeout(t,1e3*e)}))];case 3:return n.sent(),[3,1];case 4:return[2]}}))}))},t.prototype.stopRefreshingReriodically=function(){return o(this,void 0,void 0,(function(){return r(this,(function(e){return this.isPeriodicallyRefreshing=!1,[2]}))}))},t}(l.ViewController);t.BACNET_DIAG=s},function(e,t,n){var i=n(17);"string"==typeof i&&(i=[[e.i,i,""]]);var a={insert:"head",singleton:!1};n(19)(i,a);i.locals&&(e.exports=i.locals)},function(e,t,n){(e.exports=n(18)(!1)).push([e.i,'wbm-bacnet-diag div.form {\n    max-width: none !important;\n}\n\nwbm-bacnet-diag input[type="text"] {\n    width: 100px !important;\n}\n\nwbm-bacnet-diag textarea {\n    width: 100%;\n    margin: 0px;\n    padding: 5px;\n    resize: vertical;\n    height: 500px;\n    white-space: pre;\n}\n\nwbm-bacnet-diag div.section-body {\n    position: relative;\n}\n\nwbm-bacnet-diag div.indicator {\n    position: absolute;\n    left: 0;\n    right: 0;\n    top: 0;\n    bottom: 0;\n    margin: auto;\n}',""])},function(e,t,n){"use strict";e.exports=function(e){var t=[];return t.toString=function(){return this.map((function(t){var n=function(e,t){var n=e[1]||"",i=e[3];if(!i)return n;if(t&&"function"==typeof btoa){var a=(r=i,l=btoa(unescape(encodeURIComponent(JSON.stringify(r)))),s="sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(l),"/*# ".concat(s," */")),o=i.sources.map((function(e){return"/*# sourceURL=".concat(i.sourceRoot).concat(e," */")}));return[n].concat(o).concat([a]).join("\n")}var r,l,s;return[n].join("\n")}(t,e);return t[2]?"@media ".concat(t[2],"{").concat(n,"}"):n})).join("")},t.i=function(e,n){"string"==typeof e&&(e=[[null,e,""]]);for(var i={},a=0;a<this.length;a++){var o=this[a][0];null!=o&&(i[o]=!0)}for(var r=0;r<e.length;r++){var l=e[r];null!=l[0]&&i[l[0]]||(n&&!l[2]?l[2]=n:n&&(l[2]="(".concat(l[2],") and (").concat(n,")")),t.push(l))}},t}},function(e,t,n){"use strict";var i,a={},o=function(){return void 0===i&&(i=Boolean(window&&document&&document.all&&!window.atob)),i},r=function(){var e={};return function(t){if(void 0===e[t]){var n=document.querySelector(t);if(window.HTMLIFrameElement&&n instanceof window.HTMLIFrameElement)try{n=n.contentDocument.head}catch(e){n=null}e[t]=n}return e[t]}}();function l(e,t){for(var n=[],i={},a=0;a<e.length;a++){var o=e[a],r=t.base?o[0]+t.base:o[0],l={css:o[1],media:o[2],sourceMap:o[3]};i[r]?i[r].parts.push(l):n.push(i[r]={id:r,parts:[l]})}return n}function s(e,t){for(var n=0;n<e.length;n++){var i=e[n],o=a[i.id],r=0;if(o){for(o.refs++;r<o.parts.length;r++)o.parts[r](i.parts[r]);for(;r<i.parts.length;r++)o.parts.push(y(i.parts[r],t))}else{for(var l=[];r<i.parts.length;r++)l.push(y(i.parts[r],t));a[i.id]={id:i.id,refs:1,parts:l}}}}function c(e){var t=document.createElement("style");if(void 0===e.attributes.nonce){var i=n.nc;i&&(e.attributes.nonce=i)}if(Object.keys(e.attributes).forEach((function(n){t.setAttribute(n,e.attributes[n])})),"function"==typeof e.insert)e.insert(t);else{var a=r(e.insert||"head");if(!a)throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");a.appendChild(t)}return t}var u,d=(u=[],function(e,t){return u[e]=t,u.filter(Boolean).join("\n")});function f(e,t,n,i){var a=n?"":i.css;if(e.styleSheet)e.styleSheet.cssText=d(t,a);else{var o=document.createTextNode(a),r=e.childNodes;r[t]&&e.removeChild(r[t]),r.length?e.insertBefore(o,r[t]):e.appendChild(o)}}function p(e,t,n){var i=n.css,a=n.media,o=n.sourceMap;if(a&&e.setAttribute("media",a),o&&btoa&&(i+="\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(o))))," */")),e.styleSheet)e.styleSheet.cssText=i;else{for(;e.firstChild;)e.removeChild(e.firstChild);e.appendChild(document.createTextNode(i))}}var h=null,b=0;function y(e,t){var n,i,a;if(t.singleton){var o=b++;n=h||(h=c(t)),i=f.bind(null,n,o,!1),a=f.bind(null,n,o,!0)}else n=c(t),i=p.bind(null,n,t),a=function(){!function(e){if(null===e.parentNode)return!1;e.parentNode.removeChild(e)}(n)};return i(e),function(t){if(t){if(t.css===e.css&&t.media===e.media&&t.sourceMap===e.sourceMap)return;i(e=t)}else a()}}e.exports=function(e,t){(t=t||{}).attributes="object"==typeof t.attributes?t.attributes:{},t.singleton||"boolean"==typeof t.singleton||(t.singleton=o());var n=l(e,t);return s(n,t),function(e){for(var i=[],o=0;o<n.length;o++){var r=n[o],c=a[r.id];c&&(c.refs--,i.push(c))}e&&s(l(e,t),t);for(var u=0;u<i.length;u++){var d=i[u];if(0===d.refs){for(var f=0;f<d.parts.length;f++)d.parts[f]();delete a[d.id]}}}}},function(e,t){e.exports='<div taid=form-bacnet-diag class=form> <span class=title taid=form-title>Refresh Options</span> <div class=body> <div class=section> <div class=section-body> <div taid=field-limit class=field> <label taid=field-title>Read only the last</label> <div class="control textfield"> <input type=checkbox taid=field-control checked=checked> <span class=checkbox></span> <input type=text value=20 taid=field-control class=no-validation> </div> </div> <div taid=field-automatic-refresh-interval class=field> <label taid=field-title>Automatic refresh interval (sec)</label> <div class="control textfield"> <input type=checkbox taid=field-control> <span class=checkbox></span> <input type=text value=20 taid=field-control class=no-validation disabled=disabled> </div> </div> </div> <div class=actions> <button class=action id=refresh>Refresh</button> </div> </div> <div class=section> <div class=section-body> <div class=field> <textarea readonly=readonly></textarea> <div style=display:none class=indicator></div> </div> </div> </div> </div> </div>'}])}));
//# sourceMappingURL=bacnet.js.map